# Jednoduchý formulář jako datová struktura

import micro_widget as mw

def make_form_label(window):
    label = mw.make_label(window)
    mw.set_label_text(label, "Jméno:")
    mw.set_label_x(label, 20)
    mw.set_label_y(label, 10)
    return label

def make_form_entry(window):
    entry = mw.make_entry(window)
    mw.set_entry_x(entry, 20)
    mw.set_entry_y(entry, 30)
    return entry

def make_form_button(window):
    button = mw.make_button(window)
    mw.set_button_text(button, "Registrace")
    mw.set_button_x(button, 20)
    mw.set_button_y(button, 60)
    mw.set_button_click_handler(button, form_button_click_handler)
    return button
    
def make_form(window):
    label = make_form_label(window)
    entry = make_form_entry(window)
    button = make_form_button(window)
    form = ["form", label, entry, button]
    mw.set_button_data(button, form)
    return form

def get_form_entry(form):
    return form[2]

def form_button_click_handler(button):
    form = mw.get_button_data(button)
    entry = get_form_entry(form)
    text = mw.get_entry_text(entry)
    print("Registrace uživatele:", text)
    
window = mw.display_window()
form = make_form(window)





